% ToolboxTestScript
% 
% ToolboxTestScript will call all elements of the toolbox and test them appropriately.
% Figures and expected results will be shown and explained.
% All elements will be tested to ensure proper functionality.
% 
% Created: June 15, 2004
% Authors: Lily Brown, Justin Evert, Tim Stolldorf
% Marquette University

% TKDE Toolbox requires various other toolboxes to run.
% REFER USER TO README.TXT FILE.

% Tested in this script:
% * classify [x]
% * classifyTDNN [x]
% * createFolds [x]
% * createFoldSets [x]
% * createLags [x]
% * determineDimension [x]
% * determineTimeLag [x]
% * gmmactiv [] --> replace netlab version
% * learnModels [x]
% * learnTDNNModels [x]
% * makegmmPlot [x]
% * plotResults [x]
% * randomizeArray[x] 

format compact;

% fprintf('\n');
% disp('Test of determineTimeLag and determineDimension:');
% fprintf('\n');
% load('.\data\motorCurrent.mat');
% disp('An array of logistic signals is passed to determineTimeLag.');
% z1 = cell(500,1);
% for i = 1:500
% %     newSig1 = logistic(1000,4);
%     newSig1 = timeSeries{i,2};
%     z1{i}=newSig1;
% end
% timeLag = determineTimeLag(z1)
% disp('The array and the newly calculated timeLag are passed to determineDimension.');
% dimension = determineDimension(z1,timeLag)

% fprintf('\n');
% disp('Test of createLags:');
% fprintf('\n');
% disp('Function called for (1) input 3-d, lag 1 and (2) input 3-d, lag 2');
% disp('Zero is implied and will be added in the embedding process');
% lags = createLags(3,1)
% lags = createLags(3,2)

% fprintf('\n');
% disp('Test of RPS/GMM classifier');
% fprintf('\n');
% load('.\data\phonemes.mat');
% size31 = size(timeSeries)
% [models, timeLag, dimension] = learnModels(timeSeries, 2);
% sig31 = timeSeries{1,2};
% size31 = size(sig31)
% sig32 = timeSeries{2,2};
% size32 = size(sig32)
% class = classify(sig31, models, timeLag, dimension)
% class = classify(sig32, models, timeLag, dimension)
% 
% fprintf('\n');
% disp('Test of TDNN classifier');
% [models dimension] = learnTDNNModels(timeSeries);
% class = classifyTDNN(sig31, models, dimension)
% class = classifyTDNN(sig32, models, dimension)

% fprintf('\n');
% disp('Test of createFolds - Will return indices of of data for each fold');
% fprintf('\n');
% disp('Example: returns indices for 10-fold cross-validation');
% foldsIndices = createFolds('.\data\motorCurrent.mat', 10)
% disp('Test of createFoldSets - Takes fold indices and puts the data into proper folds');
% [leaveInTimeSeries, leaveOutTimeSeries] = createFoldSets(timeSeries,foldsIndices(1),8);
% leaveInTimeSeries
% leaveOutTimeSeries

% 
% % !! The following code was written by J. Evert.  It was left unfinished.
% % disp('Test of classifiers');
% % disp('Uses folds created above');
% % mixVec = [1 2 4 8 16 32]; % number of mixtures to use for training
% % accRPS  = zeros(length(mixVec));
% % accTDNN = zeros(length(mixVec));
% % for m = 1:length(mixVec)
% %     for i = 1:10
% %         [leaveInTimeSeries, leaveOutTimeSeries] = createFoldSets(timeSeries,foldsIndices,i);
% %         [models, timeLag, dimension] = learnModels(leaveInTimesSeries, mixVec(m));
% %         for j = 1:length(leaveOutFold)
% %             class = classify(leaveOutFold(j),models,timeLag,dimension);
% %             if class = % Create confusion matrix by testing class returned against class of individual signal
% 
% fprintf('\n');
% disp('Test of makegmmPlot');
% hold off;
% y(1:100) = whitenoise(100,1,1);
% y(101:200) =whitenoise(100,20,1);
% sig5 = embed(y,1,2);
% makegmmPlot(sig5',2);
% 
% fprintf('\n');
% disp('Test of plotResults');
% plotResults; 
% 
% fprintf('\n');
% disp('Test of randomizeArray');
% for i = 1:100
%     array(i) = i;
% end
% randomized = randomizeArray(array)
% 